#
# rhn_register.py - GUI front end code for firstboot screen resolution
#
# Copyright 2003 Red Hat, Inc.
# Copyright 2003 Brent Fox <bfox@redhat.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import string
import gtk
import gobject
import sys
import os
import functions

import gnome, gnome.ui
from gtk import glade

from rhpl.firstboot_gui_window import FirstbootGuiWindow
sys.path.insert(0,"/usr/share/rhn/up2date_client/")
sys.path.insert(1, "/usr/share/rhn")

import rhnreg
import rhnregGui
import up2dateErrors
import messageWindow


from rhpl.translate import _, N_
from rhpl import translate
translate.textdomain("up2date")
gtk.glade.bindtextdomain ("up2date")


class RhnWindow(FirstbootGuiWindow, rhnregGui.NewAccountPage):
    #You must specify a runPriority for the order in which you wish your module to run
    runPriority = 108
    moduleName = _("Create Login")
    windowTitle = moduleName
    internalName = "Create Login"
    htmlTag = "rhn"
    shortMessage = _("Create a new Red Hat Network account")
    needsparent = 1
    needsnetwork = 1

    def __init__(self):
        FirstbootGuiWindow.__init__(self)
        rhnregGui.NewAccountPage.__init__(self)
        if not rhnregGui.useRHN():
            self.skipme = 1

    def passInParent(self, parent):
        self.parent = parent

    def getNext(self):
        pass
    

    def setupScreen(self):

        self.icon = functions.imageFromPath("/usr/share/system-config-display/pixmaps/system-config-display.png")
        self.mainVBox = gtk.VBox()

        internalVBox = gtk.VBox(gtk.FALSE, 10)
        internalVBox.set_border_width(10)

        vbox  = self.newAccountPagePrepare()

        internalVBox.pack_start(vbox, gtk.TRUE)
        self.mainVBox.pack_start(internalVBox, gtk.TRUE)

    def launch(self, doDebug=None):
        self.doDebug = doDebug
        self.setupScreen()
        return self.mainVBox, self.icon, self.windowTitle

    #FIXME: this is a cut&paste from up2date/gui.py, need to refactor
    def grabAndVerifyFields(self):
        return self.newAccountPageVerify()

    def apply(self, *args):
#        if self.doDebug:
#            print "applying monitor changes not available in debug mode"
#            return 0

        ret =  self.grabAndVerifyFields()
        if ret:
            return None
        
        ret = self.newAccountPageApply()
	if ret:
	    return None
	return True
	
    def grabFocus(self):
        pass

    def setArrowCursor(self):
        # gtk 1.2
#        cursor = gtk.cursor_new (GDK.LEFT_PTR)
        # gtk 2.0
        pass
##        cursor = gtk.gdk.Cursor(gtk.gdk.LEFT_PTR)
##        self.mainVBox.window.set_cursor(cursor)
##        while gtk.events_pending():
##            gtk.mainiteration(gtk.FALSE)

    def fatalError(self, error, wrap=1):
#        self.setArrowCursor()
        # FIXME
        if wrap:
            text = messageWindow.wrap_text(error)
        else:
            text = error

        dlg = messageWindow.ErrorDialog(text)
        gtk.mainquit()
#        sys.exit(1)

childWindow = RhnWindow
