#!/usr/bin/python
#
# rhn_register.py - GUI front end code for firstboot screen resolution
#
# Copyright 2003 Red Hat, Inc.
# Copyright 2003 Brent Fox <bfox@redhat.com>
# Copyright 2004 Adrian Likins <alikins@redhat.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import string
import gtk
import gobject
import sys
import os
import functions

import gnome, gnome.ui
from gtk import glade

from rhpl.firstboot_gui_window import FirstbootGuiWindow
sys.path.insert(0, "/usr/share/rhn/up2date_client/")
sys.path.insert(1, "/usr/share/rhn")

import rhnreg
import rhnregGui
import up2dateErrors
import rhn_shared
##
## I18N
## 
from rhpl.translate import _, N_
from rhpl import translate
translate.textdomain("up2date")
gtk.glade.bindtextdomain ("up2date")

class RhnWindow(FirstbootGuiWindow, rhnregGui.OptOutPage):
    runPriority=107
    moduleName = _("Why Register?")
    windowTitle = moduleName
    htmlTag = "rhn"
    shortMessage = _("Register with Red Hat Network")
    needsparent = 1
    needsnetwork = 1
    def __init__(self):
        FirstbootGuiWindow.__init__(self)
        rhnregGui.OptOutPage.__init__(self)
        if not rhnregGui.useRHN():
            self.skipme = 1

    def passInParent(self, parent):
        self.parent = parent

    def getNext(self):
        pass


    def setupScreen(self):

        self.icon = functions.imageFromPath("/usr/share/system-config-display/pixmaps/system-config-display.png")
        self.mainVBox = gtk.VBox()

        internalVBox = gtk.VBox(gtk.FALSE, 10)
        internalVBox.set_border_width(10)

        vbox  = self.optOutPagePrepare()

        internalVBox.pack_start(vbox, gtk.TRUE)
        self.mainVBox.pack_start(internalVBox, gtk.TRUE)

    def launch(self, doDebug=None):
        self.doDebug = doDebug
        self.setupScreen()
        return self.mainVBox, self.icon, self.windowTitle

    def grabAndVerifyFields(self):
        return self.optOutPageVerify()

    def writeOutOptOutMessage(self):
        filename = "/var/tmp/firstboot/%s_firstboot_finish_message" % self.runPriority
        if not os.access("/var/tmp/firstboot", os.R_OK):
            os.mkdir("/var/tmp/firstboot")
        fd = open(filename, "w")
        txt = _("""You have completed installation and system setup.
                                                                                                                                                                              
Unfortunately, your subscription was not activated.
Your system will operate, but you will not be able to access the
services that keep your system secure and supported.
                                                                                                                                                                              
To ensure that you gain access to these important services, please activate
now by visiting http://www.redhat.com/activate/
                                                                                                                                                                              
Need help? To contact a customer service representative near you, visit
http://www.redhat.com/contact/
""")
        fd.write(txt)
        fd.close()
        
    def apply(self, *args):
#        if self.doDebug:
#            print "applying monitor changes not available in debug mode"
#            return 0

        ret =  self.grabAndVerifyFields()
        if self.optInReally:
            self.parent.setPage("rhn_login_gui")
            return True

        if self.optOutReally:
            # hmm, should change this to go to the next pagsee
            # not hardcode it
            self.writeOutOptOutMessage()
            self.createSystemRegisterRemindFile()
            self.parent.setPage("create_user")
            
            return True
        
        if ret:
            return ret
        return self.optOutPageApply()

    def createSystemRegisterRemindFile(self):
        REMIND_FILE="/etc/sysconfig/rhn/rhn_register_remind"
        if not os.access(REMIND_FILE, os.R_OK):
            # touch the file to tell the applet it needs to remind
            # the user to register
            fd = open(REMIND_FILE, "w+")
            fd.close()

    def grabFocus(self):
        pass

    def optOutPageOptIn(self):
        pass
        #print "we chose to opt in"

    def optOutPageOptOut(self):
        pass
        #print "we chose to opt out"
    
    #FIXME: more cut&paste code from up2date/gui.py
    def setArrowCursor(self):
        # gtk 1.2
        #        cursor = gtk.cursor_new (GDK.LEFT_PTR)
        # gtk 2.0
        pass
 ##       cursor = gtk.gdk.Cursor(gtk.gdk.LEFT_PTR)
##        self.mainWin.window.set_cursor(cursor)
##        while gtk.events_pending():
##            gtk.mainiteration(FALSE)

    def fatalError(self, error, wrap=1):
#        self.setArrowCursor()
        # FIXME
        if wrap:
            text = messageWindow.wrap_text(error)
        else:
            text = error

        dlg = messageWindow.ErrorDialog(text)
        gtk.mainquit()
        sys.exit(1)

childWindow = RhnWindow
